#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <signal.h>

#ifdef __osf__
#include <errno.h>
#include <timers.h>
extern "C" int usleep(unsigned);
#else
#include <time.h>
#endif

#ifdef __sun__
#include "b.hh"
#include <errno.h>
#endif

#include "buffer.hh"
#include "rtp_session.hh"



extern int Leave;
extern void esci(int);

void io(int s)
{
  //cout << "CLIENT SIGIO Handler:\n";
  ;
}


int client_rx(int argc,char** argv)
{
  int           debug_mode = 0;
  unsigned int  message_queue = 700;
  unsigned int  local_port = 9010;
  unsigned int  rx_buffer_size = 32*1024;
  unsigned int  tx_buffer_size = 32*1024;
  char*         write_to_file = NULL;
  unsigned int  max_packet_number = 100;
  unsigned int  packet_interval = 1;
  unsigned int  mib_interval = 40;
  unsigned int  ssrc[32] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  
  FILE*         pFout;
  int i = 2;
  
  while(i < argc)
    {
      if(argv[i][0] != '-')
	break;
      if(argv[i][1] == '-')
	{
	  if(strcmp(argv[i],"--debug") == 0)
	    debug_mode = 1;
	  else if(strcmp(argv[i],"--message_queue") == 0)
	    message_queue = atoi(argv[++i]);
	  else if(strcmp(argv[i],"--local_port") == 0)
	    local_port = atoi(argv[++i]);
	  else if(strcmp(argv[i],"--rx_buffer_size") == 0)
	    rx_buffer_size = atoi(argv[++i]);
	  else if(strcmp(argv[i],"--tx_buffer_size") == 0)
	    tx_buffer_size = atoi(argv[++i]);
	  else if(strcmp(argv[i],"--write_to_file") == 0)
	    write_to_file = argv[++i];
	  else if(strcmp(argv[i],"--max_packet_number") == 0)
	    max_packet_number = atoi(argv[++i]);
	  else if(strcmp(argv[i],"--packet_interval") == 0)
	    packet_interval = atoi(argv[++i]);
	  else
	    cerr << "unrecognized option: " << argv[i] << '\n';
	}
      else
	{
	  if(argv[i][1] == 'd')
	    debug_mode = 1;
	  else if(argv[i][1] == 'm')
	    message_queue = atoi(argv[++i]);
	  else if(argv[i][1] == 'p')
	    local_port = atoi(argv[++i]);
	  else if(argv[i][1] == 'r')
	    rx_buffer_size = atoi(argv[++i]);
	  else if(argv[i][1] == 't')
	    tx_buffer_size = atoi(argv[++i]);
	  else if(argv[i][1] == 'n')
	    max_packet_number = atoi(argv[++i]);
	  else if(argv[i][1] == 'W')
	    write_to_file = argv[++i];
	  else if(argv[i][1] == 'i')
	    packet_interval = atoi(argv[++i]);
	  else
	    cerr << "unrecognized option: -" << argv[i][1] << '\n';
	}
      i++;
    }
  
  cerr << "debug_mode:\t" << debug_mode << '\n';
  cerr << "message_queue:\t" << message_queue << '\n';
  cerr << "local_port:\t" << local_port << '\n';
  cerr << "rx_buffer_size:\t" << rx_buffer_size << '\n';
  cerr << "tx_buffer_size:\t" << tx_buffer_size << '\n';
  cerr << "max_packet_number:\t" << max_packet_number << '\n';
  cerr << "write_to_file:\t" << write_to_file << '\n';      
  cerr << "packet_interval:\t" << packet_interval << '\n';
  
  /*
     if(argc != 7)
     {
     cerr << "Usage:\t rtpd R local_port rcvbuffer sndbuffer dp num_pck\n";
     exit(-1);
     }
     */
  
  /*
     int dp = atoi(argv[5]);
     int num_pck = atoi(argv[6]);
     */
  int pckcnt  = 0;
  int pckcnt2 = 0;
  
  
  
  
  RTP_Session*  prtp_R = 
    RTP_Session::Open_RTP_Session(message_queue,
				  message_queue+1,
				  local_port,
				  rx_buffer_size,
				  tx_buffer_size,
				  debug_mode);
  cout << "session opned\n";  

  signal(SIGTERM,esci);
  
  if(write_to_file != NULL)	
    {
      pFout = fopen(write_to_file,"w");
      if(pFout == NULL)
	exit -1;
    }
  
  
  char reply[128];
  char TheData[64000];
  int  rx_length = 0;
  
  unsigned int     rx_ssrc;
  int              ssrc_count = 0;

  cout << "Number of SSRC received: " << ssrc_count << '\n';
  while(1)
    {
      if(prtp_R->ReadMIB("1.1.1",reply) == 0)
	ssrc_count = atoi(reply); 
      else
	cerr << "error on getting info\n";
      
      if(ssrc_count > 0)
	{
	  cout << "Number of SSRC received: " << ssrc_count << '\n';
	  if(prtp_R->ReadMIB("1.1.2.1.1",reply) == 0)
	    {
	      ssrc[0] = atoi(reply);
	      cout << "\nFirst ssrc rx = " << ssrc[0] << '\n';
	      prtp_R->WriteMIB("1.1.2.1.3","START");
	      break;
	    }
	}
      else
	sleep(1);
    }

  signal(SIGIO,io);
  prtp_R->SetAsync();

  cout << "entering main\n";
  while(Leave == 0)
    {
      //cerr << "pckcnt:\t" << pckcnt << '\n';
      //cerr << "Leave:\t" << Leave << '\n';
      
      while(1)
	{
	  rx_length = prtp_R->ReceiveSync(0,&rx_ssrc,(void*)TheData,64000);
 
	  if(rx_length > 0)
	    {
	      pckcnt++;
	      pckcnt2++;
	      signal(SIGIO,io);
	      break;
	    }
	  else
	    pause();
	}
      
      if(write_to_file != NULL)
	{
	  if(fwrite(TheData,rx_length,1,pFout) < 0)
	    {
	      perror("writing");
	      continue;
	    }
	}
      else
	if(pckcnt2 == packet_interval)
	  {
	    //cout << "Last Message is: " << (char*) TheData << '\n';
	    if(prtp_R->ReadMIB("1.1.1",reply) == 0)
	      ssrc_count = atoi(reply); 
	    else
	      cerr << "error on getting info\n";
	    
	    cout << "Number of SSRC received: " << ssrc_count << '\n';
	    cout << "Received packet:\t" << pckcnt
	      << "\tLast message length is: " << rx_length << '\n';
	    pckcnt2 = 0;
	  }
      
      if(pckcnt == max_packet_number)
	Leave = 1;
    }
  
  cout << "Number of packets received:\t" << pckcnt << '\n'; 
  
  if(write_to_file != NULL)
    fclose(pFout);
  
  RTP_Session::Close_RTP_Session(prtp_R);
  
  return 0;  
}
